/*
  Simple CAVE-to-CAVE application with CAVE functionality

  This program contacts the CAVE application called "Argonne CAVE" and
  tracks its user.  You will see the remote user navigating through the
  coordinate space with the default (stick-man) user representation
*/
#include <cave.h>                       /* CAVE library */
#include <c2c.h>                        /* CAVE-to-CAVE library */

void UserDraw(void);                    /* Prototype for drawing function */

void main(int argc,char *argv[])
{ /* main */
  c2cWorldDataInit();			/* Perform PreInitialization */
  CAVEConfigure(&argc,argv,NULL);       /* Get CAVE configuration info */
  CAVEInit();                           /* Start CAVE application */
  CAVEDisplay(UserDraw,0);              /* Assign drawing function */
  c2cWorldInit(&argc,argv);		/* Start CAVE-to-CAVE functionality */
  c2cTrackUserInit("Argonne CAVE",NULL);/* Track Argonne user with default user rendering */
  while(!getbutton(ESCKEY))             /* Wait for escape key */
  { /* While */
    /* Do computation here or spin endlessly */
  } /* While */
  c2cTrackUserExit("Argonne CAVE",NULL);/* Stop tracking Argonne user */
  c2cWorldExit();                       /* End CAVE-to-CAVE functionality */
  CAVEExit();                           /* End the CAVE application */  
} /* main */  

/*
  User drawing function with CAVE-to-CAVE functionality
*/
void UserDraw(void)
{ /* UserDraw */
  float bg[3] = {0,0,0};
  
  c3f(bg);
  clear();                              /* Clear frame buffers */
  zclear();
  c2cDrawAllUsers();          /* Draw remote user */
} /* UserDraw */
