/*
  Simple CAVE-to-CAVE application without CAVE functionality

  This client receives a stream and processes it in UserData callback
*/
#include <c2c.h>                        /* CAVE-to-CAVE library */
#include <stdio.h>			/* Standard I/I */

#define APP_NAME_STREAM 10              /* Requested stream id */

void UserData(void *data, CAVEId id); /* Callback prototype */

void main(int argc,char *argv[])
{ /* main */
  c2cWorldInit(&argc,argv);              /* Start CAVE-to-CAVE functionality */
  c2cWorldDataSubscribe("Argonne Simulation Server",  /* Subscribe to stream */
                        APP_NAME_STREAM,UserData);
  while(1)                               /* Spin endlesslyy */
  { /* While */
    /* Do some computation here or spin endlessly */
  } /* While */
  c2cWorldExit();                       /* End CAVE-to-CAVE functionality */
} /* main */  

/*
  This is the callback called when the stream data is received
*/
void UserData(void *databuffer, CAVEId id)
{ /* UserData */
  char remotedata[C2C_NAME_SIZE];       /* Data buffers */
  int type;
  long longdata;
  float floatdata;
  double doubledata;

  c2cGetChar(databuffer,remotedata,C2C_NAME_SIZE); /* Read the data */
  c2cGetInt(databuffer,&type,1);
  c2cGetLong(databuffer,&longdata,1);
  c2cGetFloat(databuffer,&floatdata,1);
  c2cGetDouble(databuffer,&doubledata,1);
  c2cFreeGetBuffer(databuffer);         /* Get rid of data buffer */
  printf("Received data character %s\n",remotedata);
  printf("                integer %d\n",type);
  printf("                   long %d\n",longdata);
  printf("                  float %f\n",floatdata);
  printf("                 double %f\n",doubledata);
  printf("from source %d\n",id);
} /* UserData */
