/*
  Simple CAVE-to-CAVE application without CAVE functionality

  This server sends a stream of data (its app name) to everyone
  subscribed to it
*/
#include <c2c.h>                        /* CAVE-to-CAVE library */
#include <stdio.h>;                     /* Standard I/O library */

#define APP_NAME_STREAM 10              /* Requested stream id */

void main(int argc,char *argv[])
{ /* main */
  c2cBuffer *databuffer;		/* Data buffer to pack */
  long longdata = 12345678;
  float floatdata = 9876.543;
  double doubledata = 5738.5674;

  c2cWorldInit(&argc,argv);		/* Start CAVE-to-CAVE functionality */
  c2cRegisterStream(APP_NAME_STREAM,NULL);	/* Register stream to cast */
  while(1)				/* Wait for escape key */
  { /* While */
    c2cInitPackBuffer(&databuffer);	/* Initialize pack buffer */
    c2cPackChar(&databuffer,&c2cEnv.name,/* Pack the sending buffer */
                C2C_NAME_SIZE);
    c2cPackInt(&databuffer,&c2cEnv.type,1);
    c2cPackLong(&databuffer,&longdata,1);
    c2cPackFloat(&databuffer,&floatdata,1);
    c2cPackDouble(&databuffer,&doubledata,1);
    c2cSendStream(&databuffer,APP_NAME_STREAM);/* Broadcast your stream */
    c2cFreePackBuffer(&databuffer);	/* Free sending data buffer */
  } /* While */
  c2cWorldExit();			/* End CAVE-to-CAVE functionality */
} /* main */  
