#
# makefile.bas
#
# rcsid = "$Header: /Net/folding.compbio.caltech.edu/bcomp/src/master/nexus/ports0/makefile.bas,v 1.12 1995/07/01 14:47:59 tuecke Exp $"
#

O_DIR=.

OBJS = \
        $(O_DIR)/p0_args.$(G_OFILE) \
        $(O_DIR)/p0_error.$(G_OFILE) \
        $(O_DIR)/p0_fileio.$(G_OFILE) \
        $(O_DIR)/p0_init.$(G_OFILE) \
        $(O_DIR)/p0_mac_func.$(G_OFILE) \
        $(O_DIR)/p0_malloc.$(G_OFILE) \
        $(O_DIR)/p0_sanity.$(G_OFILE) \
        $(O_DIR)/p0_trace.$(G_OFILE) \
        $(O_DIR)/p0_util.$(G_OFILE) \
        $(O_DIR)/$(G_PORTS0_TH_MODULE).$(G_OFILE)

OBJS_LITE = \
        $(O_DIR)/p0_args.$(G_OFILE) \
        $(O_DIR)/p0_error.$(G_OFILE) \
        $(O_DIR)/p0_init.$(G_OFILE) \
        $(O_DIR)/p0_mac_func.$(G_OFILE) \
        $(O_DIR)/p0_malloc.$(G_OFILE) \
        $(O_DIR)/p0_trace.$(G_OFILE) \
        $(O_DIR)/p0_util.$(G_OFILE)

PORTS0_CONFIG=ports0_config.h
PORTS0LITE_CONFIG=ports0lite_config.h

HDRS = \
	$(PORTS0_CONFIG) \
	$(SRC_PATH)/p0_defs.h \
	$(SRC_PATH)/p0_funcs.h \
	$(SRC_PATH)/p0_globals.h \
	$(SRC_PATH)/p0_internal.h \
	$(SRC_PATH)/p0_macros.h \
	$(SRC_PATH)/p0_types.h \
	$(SRC_PATH)/ports0.h \
	$(SRC_PATH)/$(G_PORTS0_TH_MODULE).h \
	$(SRC_PATH)/$(G_PORTS0_TH_MODULE)_i.h

INSTALL_HDRS = \
	$(PORTS0_CONFIG) \
	$(SRC_PATH)/ports0.h \
	$(SRC_PATH)/$(G_PORTS0_TH_MODULE).h 

LIBBASE = libports0
LIB = $(LIBBASE)$(FLAVOR_SUFFIX).$(G_LIBFILE)

OPT_FLAVOR = opt
SAFE_FLAVOR = safe
DEBUG_FLAVOR = debug
PROFILE_FLAVOR = profile

OPT_SUFFIX = _$(OPT_FLAVOR)
SAFE_SUFFIX = _$(SAFE_FLAVOR)
DEBUG_SUFFIX = _$(DEBUG_FLAVOR)
PROFILE_SUFFIX = _$(PROFILE_FLAVOR)

#FLAVOR_SUFFIXES = $(DEBUG_SUFFIX)
#FLAVOR_SUFFIXES = $(OPT_SUFFIX) $(DEBUG_SUFFIX)
FLAVOR_SUFFIXES = $(OPT_SUFFIX) $(DEBUG_SUFFIX) \
			$(PROFILE_SUFFIX) $(SAFE_SUFFIX)

OPT_DIR = $(OPT_FLAVOR)
SAFE_DIR = $(SAFE_FLAVOR)
DEBUG_DIR = $(DEBUG_FLAVOR)
PROFILE_DIR = $(PROFILE_FLAVOR)

OPT_DIR_LITE = $(OPT_FLAVOR)_lite
SAFE_DIR_LITE = $(SAFE_FLAVOR)_lite
DEBUG_DIR_LITE = $(DEBUG_FLAVOR)_lite
PROFILE_DIR_LITE = $(PROFILE_FLAVOR)_lite

MY_CFLAGS= $(G_CFLAGS) -I. -I$(SRC_PATH) -I$(INCLUDE_PATH) $(OTHER_CFLAGS)\
		$(FLAVOR_CFLAGS)

MY_MAKEFLAGS = -f $(G_MAKEFILE)

default:	build

build:		lib

force:

clean:	force
	- $(G_RM) -rf $(PORTS0_CONFIG) $(PORTS0LITE_CONFIG) *.o $(LIBBASE)* \
		$(OPT_DIR) $(SAFE_DIR) $(DEBUG_DIR) $(PROFILE_DIR) \
		$(OPT_DIR_LITE) $(SAFE_DIR_LITE) \
		$(DEBUG_DIR_LITE) $(PROFILE_DIR_LITE) \
		p0_test p0_testo p0_testp p0_tests p0_testo.c \
		p0_testp.c p0_tests.c \
		core a.out *.log *~ \#*

objs:		$(OBJS)

objs_lite:	$(OBJS_LITE)

lib: force	
	for i in $(FLAVOR_SUFFIXES) ; \
	  do \
	    $(G_MAKE) $(MY_MAKEFLAGS) build$${i} ; \
	    if [ $$? -ne 0 ] ; then exit 1 ; fi \
	  done


build_opt: force
	- if [ ! -d $(OPT_DIR) ] ; then $(G_MKDIR) $(OPT_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_opt.$(G_LIBFILE) \
		"O_DIR=$(OPT_DIR)" \
		"FLAVOR_SUFFIX=_opt" \
		"FLAVOR_CFLAGS=$(G_OPT_CFLAGS)"

build_safe: force
	- if [ ! -d $(SAFE_DIR) ] ; then $(G_MKDIR) $(SAFE_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_safe.$(G_LIBFILE) \
		"O_DIR=$(SAFE_DIR)" \
		"FLAVOR_SUFFIX=_safe" \
		"FLAVOR_CFLAGS=$(G_SAFE_CFLAGS)"

build_debug: force
	- if [ ! -d $(DEBUG_DIR) ] ; then $(G_MKDIR) $(DEBUG_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_debug.$(G_LIBFILE) \
		"O_DIR=$(DEBUG_DIR)" \
		"FLAVOR_SUFFIX=_debug" \
		"FLAVOR_CFLAGS=$(G_DEBUG_CFLAGS)"

build_profile: force
	- if [ ! -d $(PROFILE_DIR) ] ; then $(G_MKDIR) $(PROFILE_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_profile.$(G_LIBFILE) \
		"O_DIR=$(PROFILE_DIR)" \
		"FLAVOR_SUFFIX=_profile" \
		"FLAVOR_CFLAGS=$(G_PROFILE_CFLAGS)"


build_objs_opt: force
	- if [ ! -d $(OPT_DIR) ] ; then $(G_MKDIR) $(OPT_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs \
		"O_DIR=$(OPT_DIR)" \
		"FLAVOR_SUFFIX=_opt" \
		"FLAVOR_CFLAGS=$(G_OPT_CFLAGS)"

build_objs_safe: force
	- if [ ! -d $(SAFE_DIR) ] ; then $(G_MKDIR) $(SAFE_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs \
		"O_DIR=$(SAFE_DIR)" \
		"FLAVOR_SUFFIX=_safe" \
		"FLAVOR_CFLAGS=$(G_SAFE_CFLAGS)"

build_objs_debug: force
	- if [ ! -d $(DEBUG_DIR) ] ; then $(G_MKDIR) $(DEBUG_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs \
		"O_DIR=$(DEBUG_DIR)" \
		"FLAVOR_SUFFIX=_debug" \
		"FLAVOR_CFLAGS=$(G_DEBUG_CFLAGS)"

build_objs_profile: force
	- if [ ! -d $(PROFILE_DIR) ] ; then $(G_MKDIR) $(PROFILE_DIR) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs \
		"O_DIR=$(PROFILE_DIR)" \
		"FLAVOR_SUFFIX=_profile" \
		"FLAVOR_CFLAGS=$(G_PROFILE_CFLAGS)"


build_objs_opt_lite: force
	- if [ ! -d $(OPT_DIR_LITE) ] ; then $(G_MKDIR) $(OPT_DIR_LITE) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs_lite \
		"O_DIR=$(OPT_DIR_LITE)" \
		"FLAVOR_SUFFIX=_opt" \
		"FLAVOR_CFLAGS=$(G_OPT_CFLAGS_LITE)" \
		"PORTS0_CONFIG=$(PORTS0LITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DPORTS0_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"PORTS0_LITE=yes"

build_objs_safe_lite: force
	- if [ ! -d $(SAFE_DIR_LITE) ] ; then $(G_MKDIR) $(SAFE_DIR_LITE) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs_lite \
		"O_DIR=$(SAFE_DIR_LITE)" \
		"FLAVOR_SUFFIX=_safe" \
		"FLAVOR_CFLAGS=$(G_SAFE_CFLAGS_LITE)" \
		"PORTS0_CONFIG=$(PORTS0LITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DPORTS0_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"PORTS0_LITE=yes"

build_objs_debug_lite: force
	- if [ ! -d $(DEBUG_DIR_LITE) ] ; then $(G_MKDIR) $(DEBUG_DIR_LITE) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs_lite \
		"O_DIR=$(DEBUG_DIR_LITE)" \
		"FLAVOR_SUFFIX=_debug" \
		"FLAVOR_CFLAGS=$(G_DEBUG_CFLAGS_LITE)" \
		"PORTS0_CONFIG=$(PORTS0LITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DPORTS0_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"PORTS0_LITE=yes"

build_objs_profile_lite: force
	- if [ ! -d $(PROFILE_DIR_LITE) ] ; then $(G_MKDIR) $(PROFILE_DIR_LITE) ; fi
	$(G_MAKE) $(MY_MAKEFLAGS) objs_lite \
		"O_DIR=$(PROFILE_DIR_LITE)" \
		"FLAVOR_SUFFIX=_profile" \
		"FLAVOR_CFLAGS=$(G_PROFILE_CFLAGS_LITE)" \
		"PORTS0_CONFIG=$(PORTS0LITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DPORTS0_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"PORTS0_LITE=yes"


echo_objs:	force
	@ echo "$(OBJS)"

echo_objs_opt:		force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(OPT_DIR)" echo_objs

echo_objs_safe:		force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(SAFE_DIR)" echo_objs

echo_objs_debug:	force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(DEBUG_DIR)" echo_objs

echo_objs_profile:	force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(PROFILE_DIR)" echo_objs


echo_objs_lite:	force
	@ echo "$(OBJS_LITE)"

echo_objs_opt_lite:		force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(OPT_DIR_LITE)" echo_objs_lite

echo_objs_safe_lite:		force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(SAFE_DIR_LITE)" echo_objs_lite

echo_objs_debug_lite:	force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(DEBUG_DIR_LITE)" echo_objs_lite

echo_objs_profile_lite:	force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(PROFILE_DIR_LITE)" echo_objs_lite


echo_dummy_opt:		force

echo_dummy_safe:	force

echo_dummy_debug:	force

echo_dummy_profile:	force


install: install_libs install_headers

install_libs:
	for i in $(FLAVOR_SUFFIXES) ; \
	  do \
	    $(G_MAKE) $(MY_MAKEFLAGS) "INST_LIB=$(LIBBASE)$${i}.$(G_LIBFILE)" install_lib ; \
	    if [ $$? -ne 0 ] ; then exit 1 ; fi \
	  done

install_lib: force
	$(G_CP) $(INST_LIB) $(INSTALL_LIB_DIR)/$(INST_LIB)
	$(G_CHMOD) $(G_FILE_MODE) $(INSTALL_LIB_DIR)/$(INST_LIB)
	$(G_RANLIB) $(INSTALL_LIB_DIR)/$(INST_LIB)

install_headers: force
	for hdr in $(INSTALL_HDRS) ; do \
	  if [ -f $${hdr} ] ; then \
	    cp $${hdr} $(INSTALL_INC_DIR)/. ; \
	  fi \
	done


$(O_DIR)/p0_args.$(G_OFILE):	$(SRC_PATH)/p0_args.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_args.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_args.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_error.$(G_OFILE):	$(SRC_PATH)/p0_error.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_error.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_error.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_fileio.$(G_OFILE):	$(SRC_PATH)/p0_fileio.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_fileio.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_fileio.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_init.$(G_OFILE):	$(SRC_PATH)/p0_init.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_init.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_init.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_mac_func.$(G_OFILE):	$(SRC_PATH)/p0_mac_func.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_mac_func.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_mac_func.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_malloc.$(G_OFILE):	$(SRC_PATH)/p0_malloc.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_malloc.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_malloc.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_sanity.$(G_OFILE):	$(SRC_PATH)/p0_sanity.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_sanity.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_sanity.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_trace.$(G_OFILE):	$(SRC_PATH)/p0_trace.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_trace.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_trace.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/p0_util.$(G_OFILE):	$(SRC_PATH)/p0_util.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/p0_util.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./p0_util.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/$(G_PORTS0_TH_MODULE).$(G_OFILE):	$(SRC_PATH)/$(G_PORTS0_TH_MODULE).c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/$(G_PORTS0_TH_MODULE).c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./$(G_PORTS0_TH_MODULE).$(G_OFILE) $(O_DIR)/. ; \
	fi


$(PORTS0_CONFIG):	$(G_MAKEFILE) makefile.bas
	-$(G_RM) -f $(PORTS0_CONFIG)
	@echo "Creating $(PORTS0_CONFIG)"
	echo "" > $(PORTS0_CONFIG) ; \
	echo "#ifndef _PORTS0_INCLUDE_PORTS0_CONFIG_H" >> $(PORTS0_CONFIG) ; \
	echo "#define _PORTS0_INCLUDE_PORTS0_CONFIG_H" >> $(PORTS0_CONFIG) ; \
	echo "" >> $(PORTS0_CONFIG) ; \
	if [ "x$(PORTS0_LITE)" = "xyes" ] ; then \
	    echo "#ifndef PORTS0_LITE" >> $(PORTS0_CONFIG) ; \
	    echo "#define PORTS0_LITE" >> $(PORTS0_CONFIG) ; \
	    echo "#endif" >> $(PORTS0_CONFIG) ; \
	    echo "" >> $(PORTS0_CONFIG) ; \
	fi ; \
	echo "#define PORTS0_ARCH_$(G_ARCH)" >> $(PORTS0_CONFIG) ; \
	for i in $(G_OTHER_ARCH) DUMMY ; \
	  do \
	    echo "#define PORTS0_ARCH_$$i" >> $(PORTS0_CONFIG) ; \
	done; \
	echo "#define PORTS0_ARCH_STRING \"$(G_ARCH)\"" >> $(PORTS0_CONFIG) ; \
	echo "" >> $(PORTS0_CONFIG) ; \
	echo "#define PORTS0_TH_HEADER \"$(G_PORTS0_TH_MODULE).h\"" >> $(PORTS0_CONFIG) ; \
	echo "#define PORTS0_THI_HEADER \"$(G_PORTS0_TH_MODULE)_i.h\"" >> $(PORTS0_CONFIG) ; \
	echo "" >> $(PORTS0_CONFIG) ; \
	for i in PORTS0_DUMMY_DEFINE1 $(G_PORTS0_CONFIG) PORTS0_DUMMY_DEFINE2 ; \
	  do \
	    out1=`echo $$i | sed s/=.*$$//` ; \
	    out2=`echo $$i | sed s/$${out1}=\*//` ; \
	    echo "#ifndef $$out1" >> $(PORTS0_CONFIG) ; \
	    echo "#define $$out1 $$out2" >> $(PORTS0_CONFIG) ; \
	    echo "#endif" >> $(PORTS0_CONFIG) ; \
	    echo "" >> $(PORTS0_CONFIG) ; \
	done; \
	echo "#endif /* _PORTS0_INCLUDE_PORTS0_CONFIG_H */" >> $(PORTS0_CONFIG) ; \
	echo "" >> $(PORTS0_CONFIG) 


include $(SRC_PATH)/makefile.lnk$(G_MAKEFILE_LNK_SUFFIX)


ports0.tar: force
	tar cf ports0.tar *.c *.h makefile.bas

ports0.tar.Z: force
	tar cf - *.c *.h makefile.bas | compress > ports0.tar.Z


p0_test:	build_$(DEBUG_FLAVOR) p0_test.$(G_OFILE)
	$(G_RM) -f p0_test
	$(G_CC) $(G_DEBUG_CFLAGS) $(G_LDFLAGS) \
		-o p0_test p0_test.$(G_OFILE) \
		$(LIBBASE)_$(DEBUG_FLAVOR).$(G_LIBFILE) $(G_CLIBS)

p0_test.$(G_OFILE):	$(SRC_PATH)/p0_test.c $(SRC_PATH)/ports0.h
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) \
		-c $(SRC_PATH)/p0_test.c


p0_testo:	build_$(OPT_FLAVOR) p0_testo.$(G_OFILE)
	$(G_RM) -f p0_testo
	$(G_CC) $(G_OPT_CFLAGS) $(G_LDFLAGS) \
		-o p0_testo p0_testo.$(G_OFILE) \
		$(LIBBASE)_$(OPT_FLAVOR).a $(G_CLIBS)

p0_testo.$(G_OFILE):	$(SRC_PATH)/p0_testo.c $(SRC_PATH)/ports0.h
	$(G_CC) $(MY_CFLAGS) $(G_OPT_CFLAGS) \
		-DTEST_EXECUTABLE_NAME=\"p0_testo\" \
		-c $(SRC_PATH)/p0_testo.c


p0_testp:	build_$(PROFILE_FLAVOR) p0_testp.$(G_OFILE)
	$(G_RM) -f p0_testp
	$(G_CC) $(G_PROFILE_CFLAGS) $(G_LDFLAGS) \
		-o p0_testp p0_testp.$(G_OFILE) \
		$(LIBBASE)_$(PROFILE_FLAVOR).a $(G_CLIBS)

p0_testp.$(G_OFILE):	$(SRC_PATH)/p0_testp.c $(SRC_PATH)/ports0.h
	$(G_CC) $(MY_CFLAGS) $(G_PROFILE_CFLAGS) \
		-DTEST_EXECUTABLE_NAME=\"p0_testp\" \
		-c $(SRC_PATH)/p0_testp.c


p0_tests:	build_$(SAFE_FLAVOR) p0_tests.$(G_OFILE)
	$(G_RM) -f p0_tests
	$(G_CC) $(G_SAFE_CFLAGS) $(G_LDFLAGS) \
		-o p0_tests p0_tests.$(G_OFILE) \
		$(LIBBASE)_$(SAFE_FLAVOR).a $(G_CLIBS)

p0_tests.$(G_OFILE):	$(SRC_PATH)/p0_tests.c $(SRC_PATH)/ports0.h
	$(G_CC) $(MY_CFLAGS) $(G_SAFE_CFLAGS) \
		-DTEST_EXECUTABLE_NAME=\"p0_tests\" \
		-c $(SRC_PATH)/p0_tests.c


tc:
	$(G_RM) -f p0_testo.c p0_testp.c p0_tests.c
	$(G_SYMLINK) p0_test.c p0_testo.c
	$(G_SYMLINK) p0_test.c p0_testp.c
	$(G_SYMLINK) p0_test.c p0_tests.c
