/*
 * p0_internal.h
 */

#define _P0_SYSTEM_COMPILE

/*
 * Most modules should use macros for Ports0 calls.  But if you
 * do not want to, define PORTS0_SKIP_USE_MACROS before
 * including this file (internal.h) and functions will be used.
 */
#ifdef PORTS0_SKIP_USE_MACROS
#undef PORTS0_USE_MACROS
#else
#define PORTS0_USE_MACROS
#endif
#include "ports0.h"


#ifndef PORTS0_LITE
/*
 * Include the thread module's internal header, which should contain:
 *   1) #include's for any system headers needed internally for threads
 *   2) typedefs for internal ports0 types
 *   3) macros for internal ports0 routines
 */
#ifndef PORTS0_THI_HEADER
#define PORTS0_THI_HEADER "p0_th_i.h"
#endif

#include PORTS0_THI_HEADER

#endif /* PORTS0_LITE */


/*
 * Now include all of the necessary system headers
 */
#include <stdio.h>
#include <ctype.h>
#include <errno.h>

#ifdef PORTS0_ARCH_NEXTSTEP
#include <libc.h>
#endif

#if defined(PORTS0_ARCH_SOLARIS) || defined(PORTS0_ARCH_AXPOSF)
#include <unistd.h>
#endif

#ifdef PORTS0_ARCH_AXPOSF
#include <stdlib.h>
#endif

#ifdef PORTS0_ARCH_SUNOS41
#include <malloc.h>
#include <unistd.h>
#include <sys/param.h>
#endif

#ifdef PORTS0_ARCH_AIX
#include <sys/param.h>
#include <sys/access.h>
#endif

#ifdef PORTS0_ARCH_PARAGON
#include <sys/param.h>
#include <sys/access.h>
#include <sys/errno.h>
#define PORTS0_ARGS "Ports0Args" /* Environment variable */
#endif

#ifdef PORTS0_ARCH_SGI
#include <unistd.h>
#include <sys/param.h>
#endif

#ifdef PORTS0_ARCH_HPUX
#include <unistd.h>
#include <sys/types.h>
#include <sys/param.h>
#endif


/*
 * Now include the rest of the internal Ports0 headers.
 */
#include "p0_macros.h"
#include "p0_types.h"
#include "p0_funcs.h"
#include "p0_globals.h"
#include "p0_defs.h"

